const Lang = imports.lang;
const Mainloop = imports.mainloop;
const MessageTray = imports.ui.main.messageTray;

var old_summaryItemTitleWidth;
var timeout_handler = null;

function new_add(source) {
	this.old_add(source);
	
	if(MessageTray._summaryItemTitleWidth > 0)
	{
		if(MessageTray._summaryItemTitleWidth > old_summaryItemTitleWidth)
		{
			old_summaryItemTitleWidth = MessageTray._summaryItemTitleWidth;
		}
		MessageTray._summaryItemTitleWidth = 0;
	}
	
	let items = MessageTray._summary.get_children();
	for(i in items)
	{
		let child = items[i].get_child()
		
		if(child.old_text == undefined)
		{
			child.old_text = child.get_children()[1].get_child().get_text();
			child.get_children()[1].get_child().set_text('');
		}
	}
}

function timeout_func()
{
	if(MessageTray._summaryItemTitleWidth > 0)
	{
		MessageTray._summaryItemTitleWidth = 0;
	}
	return true;
}

function init() {
}

function enable() {
	old_summaryItemTitleWidth = MessageTray._summaryItemTitleWidth;
	MessageTray._summaryItemTitleWidth = 0;
	
	let items = MessageTray._summary.get_children();
	for(i in items)
	{
		let child = items[i].get_child()
		
		child.old_text = child.get_children()[1].get_child().get_text();
		child.get_children()[1].get_child().set_text('');
	}
	
	MessageTray.old_add = MessageTray.add;
	MessageTray.add = new_add;
	
	timeout_handler = Mainloop.timeout_add(1000, Lang.bind(this, timeout_func));
}

function disable() {
	if(timeout_handler)
		Mainloop.source_remove(timeout_handler);
	
	MessageTray.add = MessageTray.old_add;
	
	let items = MessageTray._summary.get_children();
	for(i in items)
	{
		let child = items[i].get_child();
		
		child.get_children()[1].get_child().set_text(child.old_text);
		child.old_text = undefined;
	}
	
	MessageTray._summaryItemTitleWidth = old_summaryItemTitleWidth;
}
